#include <pspkernel.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include "pg.h"
#include "dialog.h"
#include "danzeff.h"
#include "psp_irkeyb.h"

extern int bQuit;

extern u16 _menubmp[];
extern u16 _splashbmp[];
u16 *bBitmap = _menubmp;

void dlg_frame(const char *msg0, const char *msg1)
{
  int x, i;
    
  bltrect br = { 0, 0, 480, 255, 512, 256, _menubmp, 1, GE_TPSM_8888 };
  pgBitBltR(&br, 0, 17);

  // CACbCZA[CWBHBG
  if(msg0) mh_print(17, 17, msg0, WHITE);
//  pgDrawFrame(17,25,463,248,GREY);
//  pgDrawFrame(18,26,462,247,GREY);
  // Q@MlP>
  if(msg1) {
    x = (479-(strlen(msg1)*5))/2;
    for(i=0; msg1[i]; i++) if((msg1[i] & 0xf0) == 0x80) x-=5;
    mh_print(x, 271-16, msg1, WHITE);
  }
}

u8 GREY32[32] = {
  0x00, 0x10, 0x20, 0x30, 0x40, 0x50, 0x60, 0x70,
  0x80, 0x90, 0xa0, 0xb0, 0xc0, 0xd0, 0xe0, 0xf0,
  0xf0, 0xe0, 0xd0, 0xc0, 0xb0, 0xa0, 0x90, 0x80,
  0x70, 0x60, 0x50, 0x40, 0x30, 0x20, 0x10, 0x00,
};

int MessageBox(const char *msg, int type){
  int f=0, c;
  int MsgSel = 0;
  bltrect br = { 0, 0, 480, 255, 512, 256, _menubmp, 1, GE_TPSM_8888 };

  while(!bQuit) {

    readpad(0);

    if(new_pad & (PSP_CTRL_LEFT | PSP_CTRL_RIGHT)) MsgSel = !MsgSel;
    if(new_pad & (PSP_CTRL_CROSS | PSP_CTRL_CIRCLE)) { readpad(0); return MsgSel; }
    if((new_pad & (PSP_CTRL_SQUARE | PSP_CTRL_TRIANGLE)) && type) { readpad(0); return 0; }

    pgStartFrame();

    pgBitBltR(&br, 0, 17);

    mh_print(240-63, 271-15, " /  Enter   /  Back", BLACK);
    mh_print(240-64, 271-16, " /  Enter   /  Back", WHITE);

//    x = (479-(strlen(msg)*5))/2;
//    mh_print(x,97,msg, BLACK);
//    mh_print(x,96,msg, WHITE);

    f++;
    c = AY8(GREY32[f&0x1f], GREY32[f&0x1f]);

    if(type) {
      if(MsgSel) {
        pgFillBox(122, 122, 242, 146, c);
      } else {
        pgFillBox(248, 122, 368, 146, c);
      }

      mh_print(279, 126, "\tCancel", BLACK);
      mh_print(278, 125, "\tCancel", WHITE);
      mh_print(173, 126, "\tOk", BLACK);
      mh_print(172, 125, "\tOk", WHITE);
    } else {
      pgFillBox(204, 122, 276, 146, c);
      mh_print(231, 126, "\tOk", BLACK);
      mh_print(230, 125, "\tOk", WHITE);
    }

    mh_print(28,32,msg,WHITE);
    pgEndFrame();
  }
  readpad(0);
  return 0;
}

void PostProgressMessage(const char *msg, u16 curr, u16 max){
    u32 c=curr, m=max;
    bltrect br = { 0, 0, 480, 255, 512, 256, _splashbmp, 1, GE_TPSM_8888 };

    pgStartFrame();

    pgBitBltR(&br, 0, 17);
    mh_print(4,34,msg,WHITE);

    if(m) {
     pgDrawFrame(242, 34, 478, 50, GREY);
     pgFillBox(244, 36, 244+(232*c)/m, 48, WHITE);
    }

    pgEndFrame();
}

# define PSP_ALL_BUTTON_MASK 0xFFFF
# define PSP_MENU_MIN_TIME    150000

int 
VKB_InputText(char *Banner, char *outbuffer, int len) 
{
  //int x, y;
  //int d=-1;
  int f=0;
  //int VKB_x = 0, VKB_y = 0;
  int VKB_s = 0;
  int VKB_Done = 0;
  //int shift = 0;
  char tbuf[512];
  char *obuf = tbuf+1;

  SceCtrlData c;
  unsigned int old_pad;
  static int   last_time = 0;
  int         psp_irkeyb;
  int         danzeff_key;

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
  
  if(len>500) len = 500;
  
  tbuf[0] = '\t';
  memcpy(tbuf+1, outbuffer, len);
  tbuf[len] = 0;

  old_pad = 0;
  last_time  = 0;

  while(!VKB_Done && !bQuit) {
    f++;

    pgStartFrame();

    dlg_frame(Banner , " L/R/Analog:Keyboard  Start/Down:Ok  Select:Cancel  Up:Del  Left/Right:Move");
    mh_print(32,42,tbuf, WHITE);
    mh_print(32+VKB_s*10,62,"\t^", RED);

    danzeff_render();
    pgEndFrame();

    danzeff_key = 0;
# ifdef USE_PSP_IRKEYB
    psp_irkeyb = PSP_IRKEYB_EMPTY;
# endif

    while (1) {
      //sceKernelDelayThread(2000); 
      sceCtrlPeekBufferPositive(&c, 1);
      c.Buttons &= PSP_ALL_BUTTON_MASK;

# ifdef USE_PSP_IRKEYB
      psp_irkeyb = psp_irkeyb_set_psp_key(&c);
      if (psp_irkeyb != PSP_IRKEYB_EMPTY) {
        last_time = c.TimeStamp;
        break;
      }
# endif

      if ((old_pad != c.Buttons) || ((c.TimeStamp - last_time) > PSP_MENU_MIN_TIME)) {
        last_time = c.TimeStamp;
        old_pad = c.Buttons;
        break;
      }
    }

# ifdef USE_PSP_IRKEYB
    if (psp_irkeyb != PSP_IRKEYB_EMPTY) {
      if (psp_irkeyb >= ' ') {
        danzeff_key = psp_irkeyb;
      } else 
      if (psp_irkeyb == 0x8) {
        danzeff_key = DANZEFF_BS;
      } else
      if (psp_irkeyb == 0xd) {
        danzeff_key = DANZEFF_START;
      } else
      if (psp_irkeyb == 0x1b) {
        danzeff_key = DANZEFF_ESCAPE;
      }
      psp_irkeyb = PSP_IRKEYB_EMPTY;
    }
# endif
    if (! danzeff_key) {
      danzeff_key = danzeff_readInput(c);
    }
    if (danzeff_key > DANZEFF_START) {
      if (danzeff_key >= ' ') {
        obuf[VKB_s++] = danzeff_key;
      } else
      if (danzeff_key == DANZEFF_BS) {
        if(VKB_s) {
          strcpy(obuf + VKB_s-1, obuf + VKB_s);
          VKB_s--;
        }
      } else
      if (danzeff_key == DANZEFF_RIGHT) {
        VKB_s++;
      } else
      if (danzeff_key == DANZEFF_LEFT) {
        VKB_s--;
      } else
      if (danzeff_key == DANZEFF_DOWN) {
        VKB_Done=2;
      } else
      if (danzeff_key == DANZEFF_UP) {
        if(strlen(obuf)) {
          strcpy(obuf + VKB_s, obuf + VKB_s+1);
        }
      } else
      if (danzeff_key == DANZEFF_ESCAPE) {
        VKB_Done=1;
      }
  
    } else 
    if (danzeff_key == DANZEFF_START) {
      VKB_Done=2;
    } else 
    if (danzeff_key == DANZEFF_SELECT) {
      VKB_Done=1;
    }

    if(VKB_s<0) VKB_s=0;
    int length = strlen(obuf);
    if(VKB_s>length) VKB_s=length;
  }

  memcpy(outbuffer, tbuf+1, len);

  return (VKB_Done==2);
}

int 
MsgPrintf(int type, char *fmt, ...) 
{
  va_list opt;
  
  char buff[2048];
  int bufsz;
  
  va_start(opt, fmt);
  bufsz = vsnprintf( buff, (size_t) sizeof(buff), fmt, opt);
  buff[bufsz] = 0;

  if(type==2) { 
    PostProgressMessage(buff, 0, 0);
    return 0;
  } else
    return MessageBox(buff, type);
}
